routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Http\Controllers\Api\UserController;
use App\Http\Controllers\Auth\RegisterConfirmationController;
use App\Http\Controllers\BestRepliesController;
use App\Http\Controllers\FavoriteController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\ProfilesController;
use App\Http\Controllers\ReplyController;
use App\Http\Controllers\ThreadController;
use App\Http\Controllers\ThreadSubscriptionsController;
use App\Http\Controllers\UserNotificationsController;

Route::get('/', function () {
    return view('welcome');
});


Auth::routes();

Route::get('/home', [HomeController::class, 'index'])->name('home');

Route::resource('threads', 'ThreadController')->except(['show', 'destroy']);
Route::get('/threads/{channel}', [ThreadController::class, 'index'])->name('threads.index.channel');
Route::get('/threads/{channel}/{thread}/replies', [ReplyController::class, 'index']);
Route::post('/threads/{channel}/{thread}/replies', [ReplyController::class, 'store']);
Route::get('/threads/{channel}/{thread}', [ThreadController::class, 'show'])->name('threads.show');
Route::delete('/threads/{channel}/{thread}', [ThreadController::class, 'destroy'])->name('threads.destroy');

Route::post('/threads/{channel}/{thread}/subscriptions', [ThreadSubscriptionsController::class, 'store'])->middleware('auth');
Route::delete('/threads/{channel}/{thread}/subscriptions', [ThreadSubscriptionsController::class, 'destroy'])->middleware('auth');

Route::post('/replies/{reply}/favorites', [FavoriteController::class, 'store'])->name('replies.favorites');
Route::delete('/replies/{reply}/favorites', [FavoriteController::class, 'destroy'])->name('replies.favorites.destroy');
Route::delete('/replies/{reply}', [ReplyController::class, 'destroy'])->name('replies.destroy');
Route::patch('/replies/{reply}', [ReplyController::class, 'update'])->name('replies.update');

Route::post('/replies/{reply}/best', [BestRepliesController::class, 'store'])->name('best-replies.store');

Route::get('/profiles/{user}', [ProfilesController::class, 'show'])->name('profiles');
Route::get('/profiles/{user}/notifications', [UserNotificationsController::class, 'index'])->name('profiles.notification.index');
Route::delete('/profiles/{user}/notifications/{notification}', [UserNotificationsController::class, 'destroy'])->name('profiles.notification.destroy');

Route::get('/register/confirm', [RegisterConfirmationController::class, 'index'])->name('register.confirm');

Route::get('api/users', [UserController::class, 'index']);
Route::post('api/users/{user}/avatar', [UserController::class, 'storeAva'])->name('user.store.ava');

app/Models/Thread.php
<?php

namespace App\Models;

use App\Events\ThreadReceivedNewReplyEvent;
use App\Filters\ThreadFilter;
use App\Observers\ThreadObserver;
use App\Traits\RecordsActivity;
use Illuminate\Database\Eloquent\Model;

class Thread extends Model
{
    use RecordsActivity;

    protected $activitiesToRecord = ['created'];

    protected $guarded = [];

    protected $with = ['creator', 'channel'];

    protected $appends = ['isSubscribedTo'];

    protected static function boot()
    {
        parent::boot();

        static::observe(ThreadObserver::class);
    }


    public function path()
    {
        return '/threads/' . $this->channel->slug . '/' . $this->slug;
    }

    public function replies()
    {
        return $this->hasMany(Reply::class);
    }

    public function addReply($reply)
    {
        $reply = $this->replies()->create($reply);
        event(new ThreadReceivedNewReplyEvent($reply));
        return $reply;
    }

    public function creator()
    {
        return $this->belongsTo(User::class, 'user_id');
    }

    public function channel()
    {
        return $this->belongsTo(Channel::class);
    }

    public function scopeFilter($query, ThreadFilter $filters)
    {
        return $filters->apply($query);
    }

    public function subscribe(?int $userId = null)
    {
        $this->subscriptions()->create([
            'user_id' => $userId ?: auth()->id(),
        ]);
        return $this;
    }

    public function unsubscribe(?int $userId = null)
    {
        $this->subscriptions()
            ->where('user_id', $userId ?: auth()->id())
            ->delete();
        return $this;
    }

    public function subscriptions()
    {
        return $this->hasMany(ThreadSubscription::class);
    }

    public function hasUpdatesFor(User $user)
    {
        $key = $user->visitedThreadCacheKey($this);
        return $this->updated_at > cache($key);
    }

    public function markBestReply(Reply $reply)
    {
        $this->update(['best_reply_id' => $reply->id]);
    }

    public function getIsSubscribedToAttribute()
    {
        return $this->subscriptions()
            ->where('user_id', auth()->id())
            ->exists();
    }

    public function getRouteKeyName()
    {
        return 'slug';
    }

    public function setSlugAttribute($value)
    {
        if (static::whereSlug($slug = \Str::slug($value))->exists()) {
            $slug = "{$slug}-{$this->id}";
        }

        $this->attributes['slug'] = $slug;
    }

}

app/Http/Controllers/ThreadController.php
<?php

namespace App\Http\Controllers;

use App\Filters\ThreadFilter;
use App\Models\Channel;
use App\Models\Thread;
use App\Observers\Trending;
use Illuminate\Http\Request;
use Illuminate\Http\Response;

class ThreadController extends Controller
{
    /**
     * ThreadController constructor.
     */
    public function __construct()
    {
        $this->middleware('auth')->except(['index', 'show']);
        $this->middleware('must-be-confirmed')->only('store');
    }

    /**
     * Display a listing of the resource.
     *
     * @param Channel|null $channel
     * @param ThreadFilter $filters
     * @param Trending $trending
     * @return Response
     */
    public function index(Channel $channel, ThreadFilter $filters, Trending $trending)
    {
        $threads = $this->getThreads($filters, $channel);
        $trending = $trending->get();
        if (\request()->wantsJson()) {
            return $threads;
        }

        return view('threads.index', compact('threads', 'trending'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create()
    {
        return view('threads.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'title' => 'required|spamfree',
            'body' => 'required|spamfree',
            'channel_id' => 'required|exists:channels,id'
        ]);

        $thread = Thread::create([
            'user_id' => auth()->id(),
            'channel_id' => $request->get('channel_id'),
            'title' => $request->get('title'),
            'body' => $request->get('body'),
        ]);

        if (request()->wantsJson()) {
            return response($thread, 201);
        }

        return redirect($thread->path())
            ->with('flash', 'Votre discussion a été publié!');
    }

    /**
     * Display the specified resource.
     *
     * @param Channel $channel
     * @param Thread $thread
     * @param Trending $trending
     * @return Response
     */
    public function show(Channel $channel, Thread $thread, Trending $trending)
    {
        if (auth()->check()) {
            auth()->user()->read($thread);
        }
        $trending->push($thread);
        $thread->increment('visits');
        return view('threads.show', compact('thread'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Thread $thread
     * @return Response
     */
    public function edit(Thread $thread)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param Thread $thread
     * @return Response
     */
    public function update(Request $request, Thread $thread)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Channel $channel
     * @param Thread $thread
     * @return Response
     */
    public function destroy(Channel $channel, Thread $thread)
    {
        $this->authorize('update', $thread);

        $thread->delete();
        if (request()->wantsJson()) {
            return response([], 204);
        }
        return redirect(route('threads.index'));
    }

    /**
     * @param ThreadFilter $filters
     * @param Channel $channel
     * @return Thread[]|\Illuminate\Database\Eloquent\Builder[]|\Illuminate\Database\Eloquent\Collection
     */
    protected function getThreads(ThreadFilter $filters, Channel $channel)
    {
        $threads = Thread::latest()->filter($filters);
        if ($channel->exists) {
            $threads = $threads->whereChannelId($channel->id);
        }
        return $threads->paginate(5);
    }
}

resources/views/threads/_list.blade.php
@forelse($threads as $thread)
    <div class="card my-3">
        <div class="card-header">
            <div class="level">
                <div class="flex">
                    <h3>
                        <a href="{{$thread->path()}}">
                            @if(auth()->check() && $thread->hasUpdatesFor(auth()->user()))
                                <strong>
                                    {{$thread->title}}
                                </strong>
                            @else
                                {{$thread->title}}
                            @endif
                        </a>
                    </h3>
                    <h5>Par: <a href="{{route('profiles', $thread->creator->name)}}">{{$thread->creator->name}}</a> </h5>
                </div>
                <strong>
                    <a href="{{$thread->path()}}">
                        {{$thread->replies_count}} {{ Str::plural('reply', $thread->replies_count) }}
                    </a>
                </strong>
            </div>
        </div>
        <div class="card-body">
            <div class="card-body">{{$thread->body}}</div>
        </div>
        <div class="card-footer">
            {{$thread->visits}} vu
        </div>
    </div>
@empty
    <p>Maintenant, il n'y a pas de résultats pertinents.</p>
@endforelse

resources/views/threads/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">Créer un nouvelle discussion</div>

                    <div class="card-body">
                        <form action="{{route('threads.store')}}" method="post">
                            @csrf
                            <div class="form-group">
                                <label for="channel_id">Choisissez une chaîne</label>
                                <select name="channel_id" id="channel_id" class="form-control" required>
                                    <option value="">Choisissez une...</option>
                                    @foreach($channels as $channel)
                                        <option
                                            value="{{$channel->id}}" {{old('channel_id')== $channel->id ? 'selected' : ''}}>{{$channel->name}}</option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="title">Titre:</label>
                                <input type="text" class="form-control" id="title" name="title" placeholder="titre"
                                       value="{{old('title')}}" required>
                            </div>
                            <div class="form-group">
                                <label for="body">Description:</label>
                                <textarea name="body" id="body" rows="10"
                                          class="form-control" required>{{old('body')}}</textarea>
                            </div>
                            <div class="form-group">
                                <button type="submit" class="btn btn-primary">Publier</button>
                            </div>
                            @if(count($errors))
                                <ul class="alert alert-danger">
                                    @foreach($errors->all() as $error)
                                        <li>{{$error}}</li>
                                    @endforeach
                                </ul>
                            @endif
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/threads/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-8">
                @include('threads._list')
                {{$threads->links()}}
            </div>
            <div class="col-md-4">
                @if(count($trending))
                <div class="card">
                    <div class="card-header">
                        Discussions sur les tendances
                    </div>
                    <div class="card-body">
                        <ul class="list-group">
                            @foreach ($trending as $thread)
                                <li class="list-group-item">
                                    <a href="{{ url($thread->path) }}">
                                        {{ $thread->title }}
                                    </a>
                                </li>
                            @endforeach
                        </ul>
                    </div>
                </div>
                @endif
            </div>
        </div>
    </div>
@endsection

resources/views/threads/reply.blade.php
<reply :attributes="{{ $reply }}" inline-template v-cloak>
    <div id="reply-{{ $reply->id }}" class="card my-3">
        <div class="card-header">
            <div class="level">
                <h6 class="flex">
                    <a href="{{route('profiles', $reply->owner)}}">
                        {{$reply->owner->name}}
                    </a> a publié {{$reply->created_at->diffForHumans()}} ...
                </h6>
                @if(Auth::check())
                    <div>
                        <favorite :reply="{{$reply}}"></favorite>
                    </div>
                @endif
            </div>
        </div>
        <div class="card-body">
            <div v-if="editing">
                <div class="form-group">
                    <textarea class="form-control" v-model="body"></textarea>
                </div>
                <button class="btn btn-primary btn-sm" @click="update">Actualiser</button>
                <button class="btn btn-link btn-sm" @click="editing = false">Annuler</button>
            </div>
            <div v-else v-text="body"></div>
        </div>
        @can('update', $reply)
            <div class="card-footer level">
                <button class="btn btn-info btn-sm mr-1" @click="editing = true">Modifier</button>
                <button class="btn btn-danger btn-sm mr-1" @click="destroy">Supprimer</button>
            </div>
        @endcan
    </div>
</reply>

resources/views/threads/show.blade.php
@extends('layouts.app')
@section('header')
    <link href="{{ asset('css/vendor/tribute.css') }}" rel="stylesheet">
@endsection
@section('content')
    <thread-view inline-template :initial-replies-count="{{$thread->replies_count}}">
        <div class="container">
            <div class="row">
                <div class="col-md-8">
                    <div class="card">
                        <div class="card-header">
                            <div class="level">
                                <img src="{{$thread->creator->avatar_path}}"
                                     alt="{{$thread->creator->name}}" width="25" height="25" class="mr-1">
                                <span class="flex">
                                <a href="{{route('profiles', $thread->creator)}}">{{$thread->creator->name}}</a> a publié:
                                {{$thread->title}}
                            </span>
                                @can('update', $thread)
                                    <form action="{{$thread->path()}}" method="post">
                                        @csrf
                                        @method('DELETE')
                                        <button type="submit" class="btn btn-danger">Supprimer</button>
                                    </form>
                                @endcan
                            </div>
                        </div>

                        <div class="card-body">
                            {{$thread->body}}
                        </div>
                    </div>
                    <replies
                        @added="repliesCount++"
                        @removed="repliesCount--">
                    </replies>
                </div>
                <div class="col-md-4">
                    <div class="card">
                        <div class="card-body">
                            <p>Cette discussion a été publié {{$thread->created_at->diffForHumans()}} par
                                <a href="#">{{$thread->creator->name}}</a>, et a actuellement <span
                                    v-text="repliesCount"></span>
                                {{Str::plural('commentaire', $thread->replies_count)}}.
                            </p>
                            <p>
                                <subscribe-button :active="{{json_encode($thread->isSubscribedTo)}}"></subscribe-button>
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </thread-view>
@endsection